/*
 * $Id: expr.prg,v 1.1 1999/11/09 01:37:23 vszel Exp $
 */

//*******************************************************************
// expr.prg: Kifejezs hatrok megllaptsa.
// 1999, Csiszr Levente

//*******************************************************************
#include "objgen.ch"

//*******************************************************************
#include "prtree.och"
#include "prtreepr.och"

//*******************************************************************
#define EXPPRTREE_MAXDEEP 4

//*******************************************************************
function expPrtree()
// Megadja a kifejezseket vizsgl elemz ft.

// Ha az adott szrl (sorozatrl) tudni lehet, hogy hol van benne
// a kifejezs hatr, akkor a result-ban egy szm ll, ami
// a sorozat utols, mg a kifejezshez tartoz tagjnat a 
// sorszma. Ha ilyen nincs, akkor a result nil.

// A '!', '@', '++', '=' osztlyok innen hinyoznak, mert azok utn
// minden jhet.

static prtree

   if (prtree==nil)
   
      prtree:=C.PRTREE:onew()
      
      #ifdef OLD
      // Kett hosszak, amiket elfogadjunk.
      PRTREE.prtree:addWord(nil,{"%","&"}    )
      PRTREE.prtree:addWord(nil,{"%","++"}   )
      PRTREE.prtree:addWord(nil,{"%","nev"}  )
      PRTREE.prtree:addWord(nil,{"%","(a)"}  )
      PRTREE.prtree:addWord(nil,{"%",".T."}  )
      PRTREE.prtree:addWord(nil,{"%","1"}    )
      PRTREE.prtree:addWord(nil,{"^","&"}    )
      PRTREE.prtree:addWord(nil,{"^","++"}   )
      PRTREE.prtree:addWord(nil,{"^","nev"}  )
      PRTREE.prtree:addWord(nil,{"^","(a)"}  )
      PRTREE.prtree:addWord(nil,{"^",".T."}  )
      PRTREE.prtree:addWord(nil,{"^","1"}    )
      PRTREE.prtree:addWord(nil,{"&","!"}    )
      PRTREE.prtree:addWord(nil,{"&","@"}    )
      PRTREE.prtree:addWord(nil,{"&","%"}    )
      PRTREE.prtree:addWord(nil,{"&","^"}    )
      PRTREE.prtree:addWord(nil,{"&","&"}    )
      PRTREE.prtree:addWord(nil,{"&","*"}    )
      PRTREE.prtree:addWord(nil,{"&","-"}    )
      PRTREE.prtree:addWord(nil,{"&","+"}    )
      PRTREE.prtree:addWord(nil,{"&","="}    )
      PRTREE.prtree:addWord(nil,{"&","/"}    )
      PRTREE.prtree:addWord(nil,{"&","++"}   )
      PRTREE.prtree:addWord(nil,{"&","nev"}  )
      PRTREE.prtree:addWord(nil,{"&","(a)"}  )
      PRTREE.prtree:addWord(nil,{"&",".T."}  )
      PRTREE.prtree:addWord(nil,{"&","1"}    )
      PRTREE.prtree:addWord(nil,{"*","&"}    )
      PRTREE.prtree:addWord(nil,{"*","++"}   )
      PRTREE.prtree:addWord(nil,{"*","nev"}  )
      PRTREE.prtree:addWord(nil,{"*","(a)"}  )
      PRTREE.prtree:addWord(nil,{"*",".T."}  )
      PRTREE.prtree:addWord(nil,{"*","1"}    )
      PRTREE.prtree:addWord(nil,{"-","&"}    )
      PRTREE.prtree:addWord(nil,{"-","++"}   )
      PRTREE.prtree:addWord(nil,{"-","nev"}  )
      PRTREE.prtree:addWord(nil,{"-","(a)"}  )
      PRTREE.prtree:addWord(nil,{"-",".T."}  )
      PRTREE.prtree:addWord(nil,{"-","1"}    )
      PRTREE.prtree:addWord(nil,{"+","&"}    )
      PRTREE.prtree:addWord(nil,{"+","++"}   )
      PRTREE.prtree:addWord(nil,{"+","nev"}  )
      PRTREE.prtree:addWord(nil,{"+","(a)"}  )
      PRTREE.prtree:addWord(nil,{"+",".T."}  )
      PRTREE.prtree:addWord(nil,{"+","1"}    )
      PRTREE.prtree:addWord(nil,{"/","&"}    )
      PRTREE.prtree:addWord(nil,{"/","++"}   )
      PRTREE.prtree:addWord(nil,{"/","nev"}  )
      PRTREE.prtree:addWord(nil,{"/","(a)"}  )
      PRTREE.prtree:addWord(nil,{"/",".T."}  )
      PRTREE.prtree:addWord(nil,{"/","1"}    )
      PRTREE.prtree:addWord(nil,{"nev","!"}  )
      PRTREE.prtree:addWord(nil,{"nev","@"}  )
      PRTREE.prtree:addWord(nil,{"nev","%"}  )
      PRTREE.prtree:addWord(nil,{"nev","^"}  )
      PRTREE.prtree:addWord(nil,{"nev","&"}  )
      PRTREE.prtree:addWord(nil,{"nev","*"}  )
      PRTREE.prtree:addWord(nil,{"nev","-"}  )
      PRTREE.prtree:addWord(nil,{"nev","+"}  )
      PRTREE.prtree:addWord(nil,{"nev","="}  )
      PRTREE.prtree:addWord(nil,{"nev","/"}  )
      PRTREE.prtree:addWord(nil,{"nev","++"} )
      PRTREE.prtree:addWord(nil,{"nev","(a)"}) 
      PRTREE.prtree:addWord(nil,{"(a)","!"}  )
      PRTREE.prtree:addWord(nil,{"(a)","@"}  )
      PRTREE.prtree:addWord(nil,{"(a)","%"}  )
      PRTREE.prtree:addWord(nil,{"(a)","^"}  )
      PRTREE.prtree:addWord(nil,{"(a)","&"}  )
      PRTREE.prtree:addWord(nil,{"(a)","*"}  )
      PRTREE.prtree:addWord(nil,{"(a)","-"}  )
      PRTREE.prtree:addWord(nil,{"(a)","+"}  )
      PRTREE.prtree:addWord(nil,{"(a)","="}  )
      PRTREE.prtree:addWord(nil,{"(a)","/"}  )
      PRTREE.prtree:addWord(nil,{"(a)","++"} )
      PRTREE.prtree:addWord(nil,{"(a)","(a)"}) 
      PRTREE.prtree:addWord(nil,{".T.","!"}  )
      PRTREE.prtree:addWord(nil,{".T.","@"}  )
      PRTREE.prtree:addWord(nil,{".T.","%"}  )
      PRTREE.prtree:addWord(nil,{".T.","^"}  )
      PRTREE.prtree:addWord(nil,{".T.","&"}  )
      PRTREE.prtree:addWord(nil,{".T.","*"}  )
      PRTREE.prtree:addWord(nil,{".T.","-"}  )
      PRTREE.prtree:addWord(nil,{".T.","+"}  )
      PRTREE.prtree:addWord(nil,{".T.","="}  )
      PRTREE.prtree:addWord(nil,{".T.","/"}  )
      PRTREE.prtree:addWord(nil,{".T.","++"} )
      PRTREE.prtree:addWord(nil,{".T.","(a)"}) 
      PRTREE.prtree:addWord(nil,{"1","!"}    )
      PRTREE.prtree:addWord(nil,{"1","@"}    )
      PRTREE.prtree:addWord(nil,{"1","%"}    )
      PRTREE.prtree:addWord(nil,{"1","^"}    )
      PRTREE.prtree:addWord(nil,{"1","&"}    )
      PRTREE.prtree:addWord(nil,{"1","*"}    )
      PRTREE.prtree:addWord(nil,{"1","-"}    )
      PRTREE.prtree:addWord(nil,{"1","+"}    )
      PRTREE.prtree:addWord(nil,{"1","="}    )
      PRTREE.prtree:addWord(nil,{"1","/"}    )
      PRTREE.prtree:addWord(nil,{"1","++"}   )
      PRTREE.prtree:addWord(nil,{"1","(a)"}  )

      #endif

      // Kt token kztt kifejezshatrok.
      PRTREE.prtree:addWord(1,{"%","!"}    )
      PRTREE.prtree:addWord(1,{"%","@"}    )
      PRTREE.prtree:addWord(1,{"%","%"}    )
      PRTREE.prtree:addWord(1,{"%","^"}    )
      PRTREE.prtree:addWord(1,{"%","*"}    )
      PRTREE.prtree:addWord(1,{"%","-"}    )
      PRTREE.prtree:addWord(1,{"%","+"}    )
      PRTREE.prtree:addWord(1,{"%","="}    )
      PRTREE.prtree:addWord(1,{"%","/"}    )
      PRTREE.prtree:addWord(1,{"^","!"}    )
      PRTREE.prtree:addWord(1,{"^","@"}    )
      PRTREE.prtree:addWord(1,{"^","%"}    )
      PRTREE.prtree:addWord(1,{"^","^"}    )
      PRTREE.prtree:addWord(1,{"^","*"}    )
      PRTREE.prtree:addWord(1,{"^","-"}    )
      PRTREE.prtree:addWord(1,{"^","+"}    )
      PRTREE.prtree:addWord(1,{"^","="}    )
      PRTREE.prtree:addWord(1,{"^","/"}    )
      PRTREE.prtree:addWord(1,{"*","!"}    )
      PRTREE.prtree:addWord(1,{"*","@"}    )
      PRTREE.prtree:addWord(1,{"*","%"}    )
      PRTREE.prtree:addWord(1,{"*","^"}    )
      PRTREE.prtree:addWord(1,{"*","*"}    )
      PRTREE.prtree:addWord(1,{"*","-"}    )
      PRTREE.prtree:addWord(1,{"*","+"}    )
      PRTREE.prtree:addWord(1,{"*","="}    )
      PRTREE.prtree:addWord(1,{"*","/"}    )
      PRTREE.prtree:addWord(1,{"-","!"}    )
      PRTREE.prtree:addWord(1,{"-","@"}    )
      PRTREE.prtree:addWord(1,{"-","%"}    )
      PRTREE.prtree:addWord(1,{"-","^"}    )
      PRTREE.prtree:addWord(1,{"-","*"}    )
      PRTREE.prtree:addWord(1,{"-","-"}    )
      PRTREE.prtree:addWord(1,{"-","+"}    )
      PRTREE.prtree:addWord(1,{"-","="}    )
      PRTREE.prtree:addWord(1,{"-","/"}    )
      PRTREE.prtree:addWord(1,{"+","!"}    )
      PRTREE.prtree:addWord(1,{"+","@"}    )
      PRTREE.prtree:addWord(1,{"+","%"}    )
      PRTREE.prtree:addWord(1,{"+","^"}    )
      PRTREE.prtree:addWord(1,{"+","*"}    )
      PRTREE.prtree:addWord(1,{"+","-"}    )
      PRTREE.prtree:addWord(1,{"+","+"}    )
      PRTREE.prtree:addWord(1,{"+","="}    )
      PRTREE.prtree:addWord(1,{"+","/"}    )
      PRTREE.prtree:addWord(1,{"/","!"}    )
      PRTREE.prtree:addWord(1,{"/","@"}    )
      PRTREE.prtree:addWord(1,{"/","%"}    )
      PRTREE.prtree:addWord(1,{"/","^"}    )
      PRTREE.prtree:addWord(1,{"/","*"}    )
      PRTREE.prtree:addWord(1,{"/","-"}    )
      PRTREE.prtree:addWord(1,{"/","+"}    )
      PRTREE.prtree:addWord(1,{"/","="}    )
      PRTREE.prtree:addWord(1,{"/","/"}    )
      PRTREE.prtree:addWord(1,{"nev","nev"}) 
      PRTREE.prtree:addWord(1,{"nev",".T."}) 
      PRTREE.prtree:addWord(1,{"nev","1"}  )
      PRTREE.prtree:addWord(1,{"(a)","nev"}) 
      PRTREE.prtree:addWord(1,{"(a)",".T."}) 
      PRTREE.prtree:addWord(1,{"(a)","1"}  )
      PRTREE.prtree:addWord(1,{".T.","nev"}) 
      PRTREE.prtree:addWord(1,{".T.",".T."}) 
      PRTREE.prtree:addWord(1,{".T.","1"}  )
      PRTREE.prtree:addWord(1,{"1","nev"}  )
      PRTREE.prtree:addWord(1,{"1",".T."}  )
      PRTREE.prtree:addWord(1,{"1","1"}    )

      // Hrom hosszak, amiket elfogadunk.
      PRTREE.prtree:addWord(nil,{"/","-","nev"}  )
      PRTREE.prtree:addWord(nil,{"/","-","1"}    )
      PRTREE.prtree:addWord(nil,{"%","-","nev"}  )
      PRTREE.prtree:addWord(nil,{"%","-","1"}    )
      PRTREE.prtree:addWord(nil,{"^","-","nev"}  )
      PRTREE.prtree:addWord(nil,{"^","-","1"}    )
      PRTREE.prtree:addWord(nil,{"*","-","nev"}  )
      PRTREE.prtree:addWord(nil,{"*","-","1"}    )
      PRTREE.prtree:addWord(nil,{"-","-","nev"}  )
      PRTREE.prtree:addWord(nil,{"-","-","1"}    )
      PRTREE.prtree:addWord(nil,{"+","-","nev"}  )
      PRTREE.prtree:addWord(nil,{"+","-","1"}    )
      PRTREE.prtree:addWord(nil,{"+","/","nev"}  )

      // Specilis kivtelek, amiket el kell fogadni.
      PRTREE.prtree:addWord(nil,{"*","/","nev"}  )
      
      // Specilis kivtelek, amikben kifejezshatr van.
      PRTREE.prtree:addWord(2,{"nev","++","nev"} )
      PRTREE.prtree:addWord(2,{"nev","++",".T."} )
      PRTREE.prtree:addWord(2,{"nev","++","1"}   )
      PRTREE.prtree:addWord(2,{"(a)","++","nev"} )
      PRTREE.prtree:addWord(2,{"(a)","++",".T."} )
      PRTREE.prtree:addWord(2,{"(a)","++","1"}   )
      PRTREE.prtree:addWord(2,{".T.","++","nev"} )
      PRTREE.prtree:addWord(2,{".T.","++",".T."} )
      PRTREE.prtree:addWord(2,{".T.","++","1"}   )
      PRTREE.prtree:addWord(2,{"1","++","nev"}   )
      PRTREE.prtree:addWord(2,{"1","++",".T."}   )
      PRTREE.prtree:addWord(2,{"1","++","1"}     )  
      
   endif
return prtree


//*******************************************************************
#ifdef OLD
function exprChk2(clf1,clf2)
// A kt classify-rl megllaptja, hogy kvetkezhetnek-e egyms utn.
// Egyik sem lehet res (sorvgjel, etc.)
local prtreepr,w

   if (clf1=="!" .or. clf1=="@" .or. clf1=="++" .or. clf1=="=")
      return .t.
   endif


   prtreepr:=C.PRTREEPR:onew(expPrtree2())
   if (nil==(w:=PRTREEPR.prtreepr:put(clf1)))
      w:=PRTREEPR.prtreepr:put(clf2)
   endif
   
   // w==nil: Ez nem lehet, mert a fban csak kt elem szavak 
   //         vannak.
return w!=.f.

//*******************************************************************
function expPrtree3()
// Megadja a hrom elem kifejezsekre a kivteleket.
// Ezek azok, amiket az exprChk2() nem enged el, de jk.

static prtree

   if (prtree==nil)
   
      prtree:=C.PRTREE:onew()
      
      PRTREE.prtree:addWord(nil,{"/","-","nev"}  )
      PRTREE.prtree:addWord(nil,{"/","-","1"}  )
      PRTREE.prtree:addWord(nil,{"%","-","nev"}  )
      PRTREE.prtree:addWord(nil,{"%","-","1"}  )
      PRTREE.prtree:addWord(nil,{"^","-","nev"}  )
      PRTREE.prtree:addWord(nil,{"^","-","1"}  )
      PRTREE.prtree:addWord(nil,{"*","-","nev"}  )
      PRTREE.prtree:addWord(nil,{"*","-","1"}  )
      PRTREE.prtree:addWord(nil,{"-","-","nev"}  )
      PRTREE.prtree:addWord(nil,{"-","-","1"}  )
      PRTREE.prtree:addWord(nil,{"+","-","nev"}  )
      PRTREE.prtree:addWord(nil,{"+","-","1"}  )
      PRTREE.prtree:addWord(nil,{"+","/","nev"}  )
      // PRTREE.prtree:addWord(nil,{"","",""}  )
      // PRTREE.prtree:addWord(nil,{"","",""}  )
      // PRTREE.prtree:addWord(nil,{"","",""}  )
      // PRTREE.prtree:addWord(nil,{"","",""}  )
      
   endif
return prtree

//*******************************************************************
function exprChk3(clf1,clf2,clf3)
// A hrom classify-rl megllaptja, hogy kvetkezhetnek-e egyms 
// utn.
// Csak akkor hvhat, ha (clf2,clf3)-at az exprChk2() nem fogadta el.
// Egyik sem lehet res (sorvgjel, etc.)
local prtreepr,w

   prtreepr:=C.PRTREEPR:onew(expPrtree3())
   if (nil==(w:=PRTREEPR.prtreepr:put(clf1)))
      if (nil==(w:=PRTREEPR.prtreepr:put(clf2)))
         w:=PRTREEPR.prtreepr:put(clf3)
      endif
   endif
   
   // w==nil: Ez nem lehet, mert a fban csak kt elem szavak 
   //         vannak.
return w!=.f.

//*******************************************************************
function exprChk(clfArray)
// Megllptja, hogy a clfArray utols n. eleme kztt hol van
// a kifejezs hatr.
// Ret: nil, ha nincs kifejezs hatr.
//      szm: a clfArray-ban az utols, mg a kifejezshez tartoz
//            elem indexe.
local clf0,clf1,clf2
          
   if (len(clfArray)<2)
      return nil
   endif
   
   clf0:=clfArray[len(clfArray)]
   clf1:=clfArray[len(clfArray)-1]

   if (exprChk2(clf1,clf0))
      return nil
   elseif (len(clfArray)>=3)
      clf2:=clfArray[len(clfArray)-2]
      if (exprChk3(clf2,clf1,clf0))
         return nil
      endif
   endif
return len(clfArray)-1
//*******************************************************************
#endif



//*******************************************************************
function exprChk(clfArray)
// Megllaptja, hogy a clfArray utols EXPPRTREE_MAXDEEP eleme 
// kztt hol van a kifejezs hatr.
// Felteszi, hogy a clfArray els n-1 elemrl nem megllapthat, 
// hogy hol van a kifejezshatr.
// Ret: nil, ha nincs kifejezs hatr.
//      szm: a clfArray-ban az utols, mg a kifejezshez tartoz
//            elem indexe.
/*
   A kvetkezkppen mkdik:
   n=EXPPRTREE_MAXDEEP
   Megnzi, hogy a clfArray utols n elemre megllapthat-e
   kifejezshatr, ha igen, OK, ha nem, akkor az n-et cskkenti 
   egy-el. Ha az n<2, akkor a kifejezshatr nem llapthat meg.
   
   Egy n-re pedig gy llaptja meg, hogy van-e kifejezshatr, 
   hogy elemezteti az exprPrTree-vel. Ha benne van, akkor a
   result megmondja az eredmnyt. Ha nincs benne, akkor elfogadjuk.
   Ha az elemz azt mondja, hogy mg kell olvasni, akkor 
   elfogadjuk.
*/
local n, prtreepr,i,w

   for n:=EXPPRTREE_MAXDEEP to 2 step -1
      if (len(clfArray)>=n)
         prtreepr:=C.PRTREEPR:onew(expPrtree())
         for i:=len(clfarray)-n+1 to len(clfArray)
            if (nil!=(w:=PRTREEPR.prtreepr:put(clfArray[i])))
               // Az elemz megllt.
               if (w)
                  // Benne van. 
                  if (PRTREEPR.prtreepr:result==nil)
                     // Elfogadva.
                     return nil
                  endif
                  // Megvan a kifejezshatr.
                  return len(clfArray)-n+PRTREEPR.prtreepr:result
               else
                  // Nincs benne, megynk tovbb.
                  exit
               endif
            endif
         end for
      endif
   end for
   
return nil   


//*******************************************************************

