/*
 * $Id: incl.prg,v 1.1 1999/11/09 01:37:24 vszel Exp $
 */

//*******************************************************************
// incl.prg: Az INCL osztly implementcija.
// 1999, Csiszr Levente

//*******************************************************************
#include "debug.ch"

//*******************************************************************
#include "objgen.ch"

#include "lreader.och"
#include "freader.och"

#define _INCL_PRG_
#define _IMPLEMENT_ONEW_

#include "incl.och"

//*******************************************************************

implement oinit(lreader,includeList,maxInclDeep)
   super:oinit()
   this:lreader:=lreader
   this:includeList:=includeList
   this:maxInclDeep:=maxInclDeep
return this

//*******************************************************************
implement openIncludeFile(filename)
// Ret: 0: sikerlt, 1: nyitsi hiba, 2: nem tallhat, 3: tl sok
//      egymsba skatulyzs.
// Ha a name tartalmaz path-t, akkor megnzi a kurrens direktoriban 
// is, egybknt pedig csak az includeList-ben.

local fr,l

   if (this:maxInclDeep>0 .and.;
       len(LREADER.(this:lreader):readerStack)>=this:maxInclDeep)
      return 3
   endif
      
   // gy ktszer is jn hibazenet, egyszer az freader-tl, egyszer
   // pedig a hparser-tl, de ez nem baj.
   // Mj.: Ha csak egy zenetet akarunk, akkor az freader 
   //      hibazeneteit rtelmezni kell, s hparser(include) 
   //      hibazenetekk alaktani.
   fr:=C.FREADER:onew(LREADER.(this:lreader):errorStream)
   
   l:=len(FREADER.fr:errorStream)
   
   if (!dirFName(filename)=="")
      FREADER.fr:dOpen({""},filename)
      if (FREADER.fr:isError(l))
         // Nem sikerlt megnyitni.
         return 1
      endif
   endif
   
   if (!FREADER.fr:isOpen())
      FREADER.fr:dOpen(this:includeList,filename)
   endif
   
   if (FREADER.fr:isError(l))
      // Nem sikerlt megnyitni.
      return 1
   endif

   if (!FREADER.fr:isOpen())
      return 2
   endif

   // Itt kell befzni a lncba.
      
   LREADER.(this:lreader):pushReader(fr)

   PDEBUG(outstd("include: "+filename))

return 0
//*******************************************************************





