/*
 * $Id: mparser.prg,v 1.1 1999/11/09 01:37:25 vszel Exp $
 */

//*******************************************************************
// mparser.prg: A mparser osztly implementcija.
// 1999, Csiszr Levente

// A sorokban a makrkat (define, command, xcommand, translate,
// xtranslate) helyettesti.
// A PARSER-tl rkl.
// A nv s a sor (lparser) elemz ltal ksztett tokeneket vr az 
// inputrl. ltalban a hparser utn van.


/*
   Algoritmus:
      Olvas az inputjrl addig, amg el nem dnti, hogy 
      helyettesteni kell vagy nem. Ha igen, akkor a helyettests
      eredmnyt visszarakja az inputjra, ha pedig nem
      kellett helyettesteni, akkor azt kirakja az outputra.
      Ezekutn mindig nil-t ad olvassra.
*/

// #define DEBUG
//*******************************************************************
#include "debug.ch"


//*******************************************************************
#include "objgen.ch"

//*******************************************************************
#define _STRICT_PARENT_
#include "token.och"
#include "tokenst.och"
#include "edefdict.och"
#include "defdict.och"
#include "extrdict.och"
#include "xtrdict.och"
#include "reader.och"
#include "mmarker.och"
#include "tbuffer.och"
// #include "prtree.och"

#include "maltrset.och"
#include "rsmmarkr.och"
// #include "prserr.och"

//*******************************************************************
#include "cr_lf.ch"
#include "ctoken.ch"
// #include "prserr.ch"

//*******************************************************************
// sszehasonltja a (tkId, tkStr)-t egy karaterrel.
#define eqTkChar(tkId,tkStr,aChar)         ((tkId)==TKID_CHAR .and.;
                                           (tkStr)==(aChar))
                                    
//*******************************************************************
// Megnzi, hogy, ha a token TKID_CHAR, akkor a tkStr benne van-e
// az aString-ben.
#define eqTkInCharList(tkId,tkStr,aString) ((tkId)==TKID_CHAR .and.;
                                            (tkStr)$(aString))


#define PVT_IDX    1
#define PVT_NAME   2

//*******************************************************************
#define _MPARSER_PRG_
#define _IMPLEMENT_ONEW_

#include "mparser.och"

//*******************************************************************
// implement oinit(inputReader,name,defdict,errorStream)
implement oinit(inputReader,name,errorStream)
           
   super:oinit(inputReader,name,errorStream)
   // this:errorItem:=nil
   // this:defdict:=defdict
   
return this
   
//*******************************************************************
implement startMakroBuf(item)
   if (item==nil)
      this:makroBuf:={}
   else
      this:makroBuf:={item}
   endif
return nil

//*******************************************************************
implement rdsMakroBuf()
local w

   w:=this:rds()
   if (this:item!=nil)
      aadd(this:makroBuf,this:item)
   endif
return w
 
//*******************************************************************
implement unrdsMakroBuf(n)
local w,m

   w:=this:unrds(n)
   m:=len(this:makroBuf)-w
   asize(this:makroBuf,if(m>0,m,0))
   
return w

//*******************************************************************
implement readItem()
   outerr("MPARSER.o:readItem(): Ez a mvelet nem hvhat!",crlf())
return super:readItem()

#ifdef OLD
local w,tkId,tkStr
   
   /*
      Olvas a puffer-be:
      - ha nv, s az szerepel a define sztrban, akkor
         akkor indt egy define elemzt.
         Ez az elemz elmenti a parserBuffer-t, majd elvgzi
         a define objektum elemzst.
   */

   while(nil==(w:=this:getParserBuffer()) .and.;
         nil!=(w:=super:readInput()) .and.;
         TOKEN.w:id==TKID_NEV)
                     
      this:item:=w
      // Ez itt nem jhet ki!
      outerr("mparser: readItem",crlf())
      this:putParserBuffer(w)
      this:parseFun()
      
   end while
return w
#endif

//*******************************************************************
implement parseFun(edefdict)
/*
 Ez vgzi a tnyleges elemzst.
 A this:item-t elemzi, szksg esetn mg olvashat.
 Elemezi az inputon a <nv>'('<param1>,...')' paramtereket. 
 Az edefdict-nek a <nv>-hez tartoz makr defincinak kell
 lennie.

 Ret: {sikeres,itemLista}
 Ha sikeres volt, akkor a sikeres==.t., s az itemLista a csere
    eredmnye.
 Ha nem volt sikeres, akkor a sikeres==.f., s az itemLista a
    beolvasott (elreolvasott) itemek listja.
 A parserBufferben csak egy token lehet, ami az item-ben is
 van.
*/

// Mj.: Elemzskor elfogadja az res paramtereket is, ezeket csak a
//      helyettestskor szrjk ki. Ez azrt van gy, mert res
//      paramter gy is lehet res, hogy maga a token lista csupa
//      res tokenbl ll.

local state,tkId,tkStr,ujsor
local tList,i
local success,params,currentParam
local parentStack
#define STF_START  "start"
#define STF_EXPR   "expr"
#define STF_PARENT "parent"
               
   tkId:=TOKEN.(this:item):id
   tkStr:=TOKEN.(this:item):str
   
   if (EDEFDICT.edefdict:params==nil)
      // Paramterek nincsenek.
      // Ez csak egy <nv> -> <token1>,... tpus helyettests.
      this:unputParserBuffer()
      return {.t.,EDEFDICT.edefdict:change()}
   endif

   // Most elemezzk a '('<param1>,...')' -t.   
                
   parentStack:={} // Itt vannak a zrjelek.
   state:=STF_START
   success:=.f.
   this:rds()
   while(this:item!=nil)    
      tkId:=TOKEN.(this:item):id
      tkStr:=TOKEN.(this:item):str
      ujsor:=tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS .or.;
             (tkId==TKID_CHAR .and. tkStr==";")
      
      if (state==STF_START)
         if (tkId==TKID_URES)
            // Maradunk
            // state:=state
         elseif (tkId==TKID_CHAR .and. tkStr=="(")
            // Kezddik az elemzs.
            currentParam:={}
            params:={}
            state:=STF_EXPR
         else
            // Vge. Ide tartozik a sorvgjel is.
            exit
         endif
      elseif (state==STF_EXPR)
         if (tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS .or.;
             (tkId==TKID_CHAR .and. tkStr==";"))
            // Vge.
            exit
         elseif (tkId==TKID_URES)
            // Maradunk
            // state:=state
            aadd(currentParam,this:item)
         elseif (tkId==TKID_CHAR .and. tkStr==")")
            // Vge a paramter listnak.
            aadd(params,currentParam)
            success:=.t.
            exit
         elseif (tkId==TKID_CHAR .and. tkStr==",")
            // j paramter kezddik.
            aadd(params,currentParam)
            currentParam:={}
            state:=STF_EXPR
         elseif (tkId==TKID_CHAR .and.;
                 (tkStr=="(" .or. tkStr=="{" .or. tkStr=="["))
            // El kell menni a kvetkez csukig, kzben figyelni,
            // hogy rendesen zrjelezve van-e.
            aadd(currentParam,this:item)
            aadd(parentStack,thisclass:getCloseParent(tkStr))
            state:=STF_PARENT
         else
            // Ez a paramterhez tartozik.
            aadd(currentParam,this:item)
         endif
      elseif (state==STF_PARENT)
         if (ujsor)
            // Vge.
            exit
         elseif (tkId==TKID_URES)
            // Maradunk
            // state:=state
            aadd(currentParam,this:item)
         elseif (tkId==TKID_CHAR .and.;
                 (tkStr=="(" .or. tkStr=="{" .or. tkStr=="["))
            // El kell menni a kvetkez csukig, kzben figyelni,
            // hogy rendesen zrjelezve van-e.
            aadd(currentParam,this:item)
            aadd(parentStack,thisclass:getCloseParent(tkStr))
            // Maradunk
         elseif (tkId==TKID_CHAR .and. tkStr==alast(parentStack))
            aadd(currentParam,this:item)
            asize(parentStack,len(parentStack)-1)
            if (len(parentStack)==0)
               state:=STF_EXPR
            endif
         elseif (tkId==TKID_NEV)
            aadd(currentParam,this:item)
         else
            // Ez a paramterhez tartozik.
            aadd(currentParam,this:item)
         endif
      else
         ? "MPARSER:parseFun(): Ismeretlen llapot: ",state
         errorlevel(1)
         quit
      endif
      this:rds()
   end while
   
   if (success .and.;
       len(params)==1 .and.;
       0==ascan(params[1],{|x| !TOKEN.x:id==TKID_URES}))
      asize(params,0)
   endif

   if (success .and. len(params)==len(EDEFDICT.edefdict:params))
      // Sikerlt az elemzs, most meg kell csinlni a csert.
      for i:=1 to len(params)
         params[i]:=thisclass:trimTokenList(params[i])
         if (empty(params[i]))
            return {.f.,this:arrayParserBuffer()}
         endif
      end for
      #ifdef DEBUG
      outerr(crlf())
      outerr("define change: ",EDEFDICT.edefdict:printStr(),crlf())
      for i:=1 to len(params)
         outerr("params[",i,"]: ")
         aeval(params[i],{|t| outerr(TOKEN.t:getStr())})
         outerr(crlf())
      end for
      #endif
      return {.t.,EDEFDICT.edefdict:change(params)}
   endif
   // Nem sikerlt az elemzs.
return {.f.,this:arrayParserBuffer()}

//*******************************************************************
// implement printDefDict()
// return DEFDICT.(this:defdict):printStr()

//*******************************************************************
cimplement getCloseParent(aChar)
// Ha az aChar egy nyit zrjel, akkor a a csuk prjt adja, 
// egybknt nil-t.

   if (aChar=="(")
      return ")"
   elseif (aChar=="{")
      return "}"
   elseif (aChar=="[")
      return "]"
   endif
return nil

//*******************************************************************
cimplement trimTokenList(tList)
// A tList elejrl s vgrl eltvoltja az res tokeneket.
// Ret: a tList.
local i
 
   while(!empty(tList))
      if (TOKEN.(tList[1]):id!=TKID_URES)
         exit
      endif
      adel(tList,1)
      asize(tList,len(tList)-1)
   end while
   
   for i:=len(tList) to 1 step -1
      if (TOKEN.(tList[i]):id!=TKID_URES)
         asize(tList,i)
         exit
      endif
   end for

return tList

//*******************************************************************
cimplement parse(item,inputReader,name,defdict,edefdict,xtrdict,mi,errorStream,ujsor,trPrsAlg)
/*
 Itt az item csak TOKEN lehet vagy nil.
 Az inputReader-nek kell indtania az j elemzket.
 
 Az algoritmus:
    Megnzi a define sztrban, ha megvan, akkor indt egy
    elemzt r, ha az sikeres, akkor visszatr, ha nem sikeres, akkor
    visszateszi a beolvasott token sort az inputra, elkezdi indtani
    r az xtranslate makrkat. 
    Egy xtranslate makr indtsa:
    
       - Indtja a makrt, ha sikeres, akkor visszatr, ha nem, 
         akkor a token sort visszateszi az inputra.

    A maximlis hosszsg tokensort meg kell rizni, s
    azt adni teljes sikertelensg esetn.
    Msik lehetsg, hogy ravaszkodunk: beiktatunk egy tmeneti
    puffert az inputunk el (ez az mcontrol!), s 
    azt adjuk sikertelensg esetn.
*/

// Nem teljesen korrekt, mert az elemzt minden alkalommal legyrtja.

local othis,w,match,xtrList,xcmList
local i,j
   
   if (nil==item)
      return {item}
   endif
      
   match:={.f.,{item}}
   // if (TOKEN.item:id==TKID_NEV .and.;
   //     nil!=(edefdict:=DEFDICT.(defdict):atKey(TOKEN.item:str)))
   if (edefdict!=nil)
       
      othis:=class:onew(inputReader,name,defdict,xtrdict,errorStream)
      othis:item:=item
      othis:putParserBuffer(item)
      match:=othis:parseFun(edefdict)
      // Az othis inputjra visszatett tokeneket itt ki kellene venni!
      // Persze most ilyen nem lehet, mert ebbl az objektumbl senki
      // sem olvas.
      if (match[1])
         // Az illeszs sikeres volt.
         return match
      endif
   endif

   // #define XTR_SEQ
   if (trPrsAlg==TRPRA_SEQ)
      // Szekvencilis illeszts.
      xtrList:=XTRDICT.xtrdict:getExtrList(item)
      if (ujsor)
         xcmList:=XTRDICT.xtrdict:getExtrList(item,.t.)
         xtrList:=aconcatenate(xcmList,xtrList)
         //xtrList:=aconcatenate(xtrList,xcmList)
      endif
      
      // Htulrl elre haladunk.
      for i:=len(xtrList) to 1 step -1
         // Az els maga az item, ezrt azt nem kell visszatenni.
         for j:=len(match[2]) to 2 step -1
            READER.inputReader:unread(match[2][j])
         end for
         othis:=class:onew(inputReader,name,defdict,xtrdict,errorStream)
         othis:item:=item
         othis:putParserBuffer(item)
         
         match:=othis:parseXtr(xtrList[i])
      
         // Az othis inputjra visszatett tokeneket itt ki kellene venni!
         // Persze most ilyen nem lehet, mert ebbl az objektumbl senki
         // sem olvas.
      
         if (match[1])
            // Az illeszs sikeres volt.
            return match
         endif
      end for
   elseif (mi[1]!=0 .or. mi[2]!=0)
      // Fa bejrsos illeszts.
   
      // Elszr az xtranslate-eket illesztjk.
      for j:=len(match[2]) to 2 step -1
         READER.inputReader:unread(match[2][j])
      end for
      if (mi[1]!=0)
         othis:=class:onew(inputReader,name,defdict,xtrdict,errorStream)
         othis:item:=item
         othis:putParserBuffer(item)
      
         match:=othis:parseXtrTree(XTRDICT.xtrdict:trdictTree,mi[1],.f.)
   
         // Az othis inputjra visszatett tokeneket itt ki kellene venni!
         // Persze most ilyen nem lehet, mert ebbl az objektumbl senki
         // sem olvas.
         
         if (match[1])
            // Az illeszs sikeres volt.
            return match
         endif
      endif
      
      if (ujsor .and. mi[2]!=0)
         // Azutn az xcommand-okat.
         for j:=len(match[2]) to 2 step -1
            READER.inputReader:unread(match[2][j])
         end for
         othis:=class:onew(inputReader,name,defdict,xtrdict,errorStream)
         othis:item:=item
         othis:putParserBuffer(item)
         
         match:=othis:parseXtrTree(XTRDICT.xtrdict:cmdictTree,mi[2],.t.)
         
         // Az othis inputjra visszatett tokeneket itt ki kellene venni!
         // Persze most ilyen nem lehet, mert ebbl az objektumbl senki
         // sem olvas.
         
         if (match[1])
            // Az illeszs sikeres volt.
            return match
         endif
      endif
   // else
   //    for j:=len(match[2]) to 2 step -1
   //       READER.inputReader:unread(match[2][j])
   //    end for
   endif
return match

//*******************************************************************
static function nextLeftToken(o)
// Az o gy nz ki: {iLeft,leftTokenlist}
// Az iLeft mindig a beolvasandra mutat
local t
   
   while(o[1]<=len(o[2]))
      t:=o[2][o[1]]
      o[1]++
      if (TOKEN.t:id!=TKID_URES)
         return t
      endif
   end while
return nil

//*******************************************************************
static function addMatchParam(paramValues,idx,name,tokenList)
   if (paramValues[1]==PVT_IDX)
      if (len(paramValues[2])<idx)
         asize(paramValues[2],idx)
      endif
      if (paramValues[2][idx]==nil)
         paramValues[2][idx]:={tokenList}
      else
         aadd(paramValues[2][idx],tokenList)
      endif
   else
      aadd(paramValues[2],{name,tokenList})
   endif
return nil

//*******************************************************************
implement parseTokenList(leftTokenList,cmd4,paramValues,toEOL)
/*
 Ez vgzi a tnyleges elemzst. Az input folyamot megprblja 
 illeszteni a leftTokeList-re.
 A this:item-t elemzi, szksg esetn mg olvashat.
 Amikor hvjuk, akkor a parserBuffer-ben csak a this:item-nek szabad
 lennie.
 Ha a toEOL nem res, akkor csak akkor sikeres az illeszts, ha
 a sor vgig ment.
 
 Ha a cmd4 nem res, akkor a neveket 4 hosszra vgva hasonltja
 ssze.

 Ret: 0: Ha nem sikerlt az illeszts.
         Ekkor a parserBuffer-ben vannak a beolvasott tokenek.

      1: Ha sikerlt az illeszts, de nem ment elre. (Pl. egy res
         alternatva.

      2: Ha sikerlt az illeszts s elre is ment.
*/   

/*
   Megynk vgig az extrdict bal oldaln s:
   
      - Ha normal token (nem match token s nem maltrset), akkor
        annak illeszkednie kell, ha nem, akkor nem illeszkedett
        jelzssel visszatr.
        
      - Ha match token, akkor arra indtunk egy kln match 
        token elemzt. Ez az elemz megkapja a kvetkez tokent.
        
*/

// #define STX_START               "START"
#ifdef OLD
local tkId,tkStr,ujsor
local tList,i
local oLeftTList, leftToken, leftTkId, leftTkStr
local match
local w
local nUres//, utNemUresItem

   oLeftTList:={1,leftTokenList}
 
   // state:=STX_START
   // tokenList:={}
   if (nil==(leftToken:=nextLeftToken(oLeftTList)))
      // res ==> Nem illeszkedik semmire.
      return .f.      
   endif

   nUres:=0
   // utNemUresItem:=this:item
   
   while(this:item!=nil)
      leftTkId:=TOKEN.leftToken:id
      leftTkStr:=TOKEN.leftToken:str
      tkId:=TOKEN.(this:item):id
      tkStr:=TOKEN.(this:item):str
      ujsor:=tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS .or.;
             (tkId==TKID_CHAR .and. tkStr==";")
      
      if (tkId==TKID_URES)
         // Maradunk
         // aadd(tokenList,this:item)
         nUres++
      elseif (ujsor)
         // Vge. 
         // Illeszkedett, ha a leftToken egy alternatva, mert r az
         // res is illeszkedik, nem illeszkedett, ha nem az.
         // Ha illeszkedett, akkor a vgrl az jsort s az reseket
         // vissza kell tenni az inputra.
         if (leftTkId==TKID_MALTERSET)
            this:unrds(nUres+1)
            // this:item:=utNemUresItem
            // Itt nem kell a toEOL-t vizsglni.
            return .t.
         endif
         exit
      else
         if (leftTkId==TKID_MALTERSET)
            this:mleftXMRToken(leftToken,cmd4,paramValues,nUres)
            match:=.t.
            this:makroBuf:=nil
         elseif (leftTkId==TKID_REGULAR_MATCH_MARKER)
            match:=this:mleftXRMMToken(leftToken,cmd4)
         elseif (leftTkId==TKID_WILD_MATCH_MARKER)
            match:=this:mleftXWMToken(leftToken)
         elseif (leftTkId==TKID_EXT_EXPR_MATCH_MARKER)
            match:=this:mleftXEEMToken(leftToken)
         elseif (leftTkId==TKID_LIST_MATCH_MARKER)
            match:=this:mleftXLMToken(leftToken,cmd4)
         elseif (leftTkId==TKID_RESTRICTED_MATCH_MARKER)
            match:=this:mleftXRSMMToken(leftToken,cmd4)
         else
            // Egyb illeszkeds.
            match:=this:mleftXNToken(leftToken,cmd4)
            this:makroBuf:=nil
         endif
         nUres:=0
         if (!match)
            // Az illeszts nem sikerlt ==> Vge.
            exit
         endif
         // Az illeszts sikerlt, az eredmny a tokenList-ben van,
         // megynk tovbb.
         if (this:makroBuf!=nil)
            addMatchParam(paramValues,;
                          MMARKER.leftToken:mNum,;
                          MMARKER.leftToken:getName(),;
                          this:makroBuf)
         endif
         leftToken:=nextLeftToken(oLeftTList)
      endif
      if (nil==leftToken)
         // Vgig rtnk a tokenlistn.
         // Ha a toEOL nem res, akkor meg kell nzni, hogy a sor 
         // vgn vagyunk-e vagy a sor vgig csak resek vannak-e.
         if (!empty(toEOL))
            this:rds()
            while(this:item!=nil)
               tkId:=TOKEN.(this:item):id
               tkStr:=TOKEN.(this:item):str
               ujsor:=tkId==TKID_UJSOR .or.;
                      tkId==TKID_BOS .or. tkId==TKID_EOS .or.;
                      (tkId==TKID_CHAR .and. tkStr==";")
               if (tkId==TKID_URES)
                  // Megynk tovbb.
                  nUres++
               elseif (ujsor)
                  this:unrds(nUres+1)
                  return .t.
               else
                  return .f.
               endif
               this:rds()
            end while
         endif
         return .t.
      endif
      this:rds()
   end while
   
return .f.
#endif

local oLeftTList,leftToken,retVal,gone

   oLeftTList:={1,leftTokenList}

   if (nil==(leftToken:=nextLeftToken(oLeftTList)))
      // res ==> Nem illeszkedik semmire.
      return 0
   endif

   gone:=.f.   
   while(0!=(retVal:=matchLeftToken(this,leftToken,cmd4,paramValues,toEOL)))
      if (retVal==2)
         gone:=.t.
      endif
      if (nil==(leftToken:=nextLeftToken(oLeftTList)))
         if (nilLeftToken(this,toEOL))
            return if(gone,2,1)
         endif
         // Nem illeszkedett.
         return 0
      endif
      this:rds()
   end while

   // Az illeszts nem sikerlt.
return 0

//*******************************************************************
static function nilLeftToken(this,toEOL)
// Akkor kell hvni, amikor a leftToken nil
local tkId,tkStr,ujsor,nUres
                       
   nUres:=0
   // Vgig rtnk a tokenlistn.
   // Ha a toEOL nem res, akkor meg kell nzni, hogy a sor 
   // vgn vagyunk-e vagy a sor vgig csak resek vannak-e.
   if (!empty(toEOL))
      this:rds()
      while(this:item!=nil)
         tkId:=TOKEN.(this:item):id
         tkStr:=TOKEN.(this:item):str
         ujsor:=tkId==TKID_UJSOR .or.;
                tkId==TKID_BOS .or. tkId==TKID_EOS .or.;
                (tkId==TKID_CHAR .and. tkStr==";")
         if (tkId==TKID_URES)
            // Megynk tovbb.
            nUres++
         elseif (ujsor)
            this:unrds(nUres+1)
            return .t.
         else
            // Az illeszts nem sikerlt.
            return .f.
         endif
         this:rds()
      end while
   endif
return .t.

//*******************************************************************
static function matchLeftToken(this,leftToken,cmd4,paramValues,toEOL)
// Illeszt egy matchToken-t az inputra.
// A leftToken-nek nem nil-nek kell lennie.
// Ret: 0: Ha nem sikerlt az illeszts.
//         Ekkor a parserBuffer-ben vannak a beolvasott tokenek.
//
//      1: Ha sikerlt az illeszts, de nem ment elre. (Pl. egy res
//         alternatva.
//
//      2: Ha sikerlt az illeszts s elre is ment.
local tkId,tkStr,ujsor
local tList,i
local oLeftTList, leftTkId, leftTkStr
local match
local w
local nUres
local gone:=.t.

   nUres:=0
   while(this:item!=nil)
      leftTkId:=TOKEN.leftToken:id
      leftTkStr:=TOKEN.leftToken:str
      tkId:=TOKEN.(this:item):id
      tkStr:=TOKEN.(this:item):str
      ujsor:=tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS .or.;
             (tkId==TKID_CHAR .and. tkStr==";")
      
      if (tkId==TKID_URES)
         // Maradunk
         // aadd(tokenList,this:item)
         nUres++
      elseif (ujsor)
         // Vge. 
         // Illeszkedett, ha a leftToken egy alternatva, mert r az
         // res is illeszkedik, nem illeszkedett, ha nem az.
         // Ha illeszkedett, akkor a vgrl az jsort s az reseket
         // vissza kell tenni az inputra.
         if (leftTkId==TKID_MALTERSET)
            this:unrds(nUres+1)
            // this:item:=utNemUresItem
            // Itt nem kell a toEOL-t vizsglni.
            // Illeszkedik, de nem ment elre.
            return 1
         endif
         // Az illeszts nem sikerlt.
         return 0 //exit
      else
         if (leftTkId==TKID_MALTERSET)
            gone:=this:mleftXMRToken(leftToken,cmd4,paramValues,nUres)
            match:=.t.
            this:makroBuf:=nil
         elseif (leftTkId==TKID_REGULAR_MATCH_MARKER)
            match:=this:mleftXRMMToken(leftToken,cmd4)
         elseif (leftTkId==TKID_WILD_MATCH_MARKER)
            match:=this:mleftXWMToken(leftToken)
         elseif (leftTkId==TKID_EXT_EXPR_MATCH_MARKER)
            match:=this:mleftXEEMToken(leftToken)
         elseif (leftTkId==TKID_LIST_MATCH_MARKER)
            match:=this:mleftXLMToken(leftToken,cmd4)
         elseif (leftTkId==TKID_RESTRICTED_MATCH_MARKER)
            match:=this:mleftXRSMMToken(leftToken,cmd4)
         else
            // Egyb illeszkeds.
            match:=this:mleftXNToken(leftToken,cmd4)
            this:makroBuf:=nil
         endif
         nUres:=0
         if (!match)
            // Az illeszts nem sikerlt ==> Vge.
            return 0 // exit
         endif
         // Az illeszts sikerlt, az eredmny a tokenList-ben van,
         // megynk tovbb.
         if (this:makroBuf!=nil)
            addMatchParam(paramValues,;
                          MMARKER.leftToken:mNum,;
                          MMARKER.leftToken:getName(),;
                          this:makroBuf)
         endif
         // Tovbb.
         return if(gone,2,1)
         // leftToken:=nextLeftToken(oLeftTList)
      endif
      this:rds()
   end while

   // Egy olyan sor, aminek nincs sorvgjele.
   if (leftTkId==TKID_MALTERSET)
      this:unrds(nUres+1)
      // this:item:=utNemUresItem
      // Itt nem kell a toEOL-t vizsglni.
      // Illeszkedik, de nem ment elre.
      return 1
   endif
   // Az illeszts nem sikerlt.
return 0 //exit


//*******************************************************************
static function markParamValues(paramValues)
local mark,i

   mark:=array(len(paramValues[2]))
   for i:=1 to len(paramValues[2])
      if (paramValues[2][i]!=nil)
         mark[i]:=len(paramValues[2][i])
      endif
   end for
return mark

//*******************************************************************
static function restoreParamValues(paramValues,mark)
local i

   for i:=1 to len(mark)
      if (mark[i]==nil)
         paramValues[2][i]:=nil
      else
         asize(paramValues[2][i],mark[i])
      endif
   end for
   
   for i:=len(mark)+1 to len(paramValues[2])
      paramValues[2][i]:=nil
   endfor
      
return nil

//*******************************************************************
function parseDictTree(this,dictTree,cmd4,paramValues,toEOL,mi)
/*
   Elemez egy dictTree-t. Vgigprblja a fa minden gt.
   Elvgzi a helyettestst s, hogy folytathassa az elemzst, ha
   a helyettests nem vgezhet el.
   Ha az mi meg van adva, akkor az mi index node-tl indul.
   tree:=nodeList
   node:={token,nodeList[,extrDict]}
   nodeList:={node1,...}
   
   Ret: nil, ha nem sikerlt illeszteni, vagy nem lehetett 
             helyettesteni.
        tokenList: A helyettests eredmnye, ha sikerlt illeszteni
                   s sikerlt helyettesteni.
*/
local l,item,markParamValues
local i//,retVal
local extrDict,befejezheto
local mL,mItem,mMarkParamValues
local resultTkList

   l:=TBUFFER.(this:parserBuffer):bItemNumber()
   item:=this:item

   // Megynk a node-okon a legfels szinten, ha tallunk 
   // illeszkedst, akkor a fa tovbbi rszt is illesztjk, ha
   // nem, akkor visszalpnk.
   markParamValues:=markParamValues(paramValues)
   for i:=if(empty(mi),1,mi) to len(dictTree)
      if (0!=(/*retVal:=*/matchLeftToken(this,dictTree[i][1],cmd4,paramValues,toEOL)))
         // Illeszkedett
         // Megnzzk, hogy lehet-e tovbb menni.
         befejezheto:=len(dictTree[i])>=3 .and. dictTree[i][3]!=nil
         if (len(dictTree[i][2])>0)
            // Megynk lefel a fban ezen a node-on.
            if (befejezheto)
               mL:=TBUFFER.(this:parserBuffer):bItemNumber()
               mItem:=this:item
               mMarkParamValues:=markParamValues(paramValues)
            endif
            this:rds()
            if (nil!=(resultTkList:=parseDictTree(this,dictTree[i][2],cmd4,paramValues,toEOL)))
               // Sikerlt.
               return resultTkList
            endif
            if (befejezheto)
               // Vissza kell lpni.
               this:unrds(TBUFFER.(this:parserBuffer):bItemNumber()-mL)
               this:item:=mItem
               restoreParamValues(paramValues,mMarkParamValues)
            endif
         endif

         // Megnzzk, hogy itt be lehet-e fejezni.
         if (befejezheto)
            // Be lehet fejezni!
            if (nilLeftToken(this,toEOL))
               extrDict:=dictTree[i][3]
               asize(paramValues[2],EXTRDICT.extrdict:numMatchMarkers)
               if (nil!=(resultTkList:=EXTRDICT.extrdict:change(paramValues[2])))
                  return resultTkList
               endif
               // Nem sikerlt az elemzs.
            endif
            // Vissza kell lpni.
         endif
         this:unrds(TBUFFER.(this:parserBuffer):bItemNumber()-l)
         this:item:=item
         restoreParamValues(paramValues,markParamValues)
         // Nem sikerlt.
      // elseif (retVal)
      //    // Sikerlt.
      //    // Ide nem jhet!
      //    outerr("parseDictTree: retVal==.t.: Ide nem jhet!",newline())
      //    this:unrds(TBUFFER.(this:parserBuffer):bItemNumber()-l)
      //    this:item:=item
      //    restoreParamValues(paramValues,markParamValues)
      //    return nil
      else
         // Itt vissza kell lpni, s jra prblkozni.
         this:unrds(TBUFFER.(this:parserBuffer):bItemNumber()-l)
         this:item:=item
         restoreParamValues(paramValues,markParamValues)
      endif
   end while
   // A befejezst itt nem kell nzni, mert a legfels szinten
   // nem lehet befejezni (az az res szably lenne), az alsbb
   // szinteken pedig a hv nzi.
return nil
      
//*******************************************************************
implement parseXtr(extrdict)
/*
 Ez vgzi a tnyleges elemzst.
 A this:item-t elemzi, szksg esetn mg olvashat.
 Elemezi az inputon az extrdict tokenjeit. 

 Ret: {sikeres,itemLista}
 Ha sikeres volt, akkor a sikeres==.t., s az itemLista a csere
    eredmnye.
 Ha nem volt sikeres, akkor a sikeres==.f., s az itemLista a
    beolvasott (elreolvasott) itemek listja.
 A parserBufferben csak egy token lehet, ami az item-ben is
 van.
*/   

local paramValues,w
#ifdef DEBUG
local i
#endif

   paramValues:={PVT_IDX,array(EXTRDICT.extrdict:numMatchMarkers)}
   if (0!=this:parseTokenList(EXTRDICT.extrdict:leftSide,;
                           EXTRDICT.extrdict:cmdType==XTRTYPE_COMMAND .or.;
                           EXTRDICT.extrdict:cmdType==XTRTYPE_TRANSLATE,;
                           paramValues,;
                           EXTRDICT.extrdict:cmdType==XTRTYPE_XCOMMAND .or.;
                           EXTRDICT.extrdict:cmdType==XTRTYPE_COMMAND))
      // Sikerlt az elemzs, most meg kell csinlni a csert.
      #ifdef DEBUG
      outerr(crlf())
      outerr("xtranslate change: ",EXTRDICT.extrdict:printStr(),crlf())
      // for i:=1 to len(tokenList)
      //    outerr("left[",i,"]: ",TOKEN.tokenList[i]:getStr(),crlf())
      // end for
      #endif
      if (nil!=(w:=EXTRDICT.extrdict:change(paramValues[2])))
         return {.t.,w}
      endif
   endif
   // Nem sikerlt az elemzs.
return {.f.,this:arrayParserBuffer()}
   
//*******************************************************************
implement parseXtrTree(trdictTree,mi,toEOL)
/*
 Ez vgzi a tnyleges elemzst.
 A this:item-t elemzi, szksg esetn mg olvashat.
 Elemezi az inputon az extrdict tokenjeit. 
 Az mi index node-tl indul.

 Ret: {sikeres,itemLista}
 Ha sikeres volt, akkor a sikeres==.t., s az itemLista a csere
    eredmnye.
 Ha nem volt sikeres, akkor a sikeres==.f., s az itemLista a
    beolvasott (elreolvasott) itemek listja.
 A parserBufferben csak egy token lehet, ami az item-ben is
 van.
*/   

local paramValues,w//,extrDict
#ifdef DEBUG
local i
#endif

   paramValues:={PVT_IDX,{}}
   if (nil!=(w:=parseDictTree(this,trdictTree,;
                          .f.,;
                          paramValues,;
                          toEOL,mi)))
      
      // Sikerlt az elemzs, a csert a parserDict()-nek kell
      // csinlnia, hogy tovbb folytathassa az elemzst, ha
      // a helyettestst nem lehet elvgezni.
      #ifdef OLD
      asize(paramValues[2],EXTRDICT.extrdict:numMatchMarkers)
      #ifdef DEBUG
      outerr(crlf())
      outerr("xtranslate change: ",EXTRDICT.extrdict:printStr(),crlf())
      // for i:=1 to len(tokenList)
      //    outerr("left[",i,"]: ",TOKEN.tokenList[i]:getStr(),crlf())
      // end for
      #endif
      if (nil!=(w:=EXTRDICT.extrdict:change(paramValues[2])))
         return {.t.,w}
      endif
      #endif
      return {.t.,w}
   endif
   // Nem sikerlt az elemzs.
return {.f.,this:arrayParserBuffer()}
   
//*******************************************************************
function isMatchNToken(tkId,tkStr,mTkId,mTkStr,cmd4)
// Egy norml token illeszkedi-e egy norml (bal oldalon lv) 
// tokenre.
// Mj.: A tk s az mTk nem cserlhet fel egymssal!

   if (tkId==TKID_NEV)
      return mTkId==TKID_NEV .and. compareWNames(tkStr,mTkStr,cmd4)
   elseif (tkId==TKID_STRING)
      return mTkId==TKID_STRING .and. compareWNames(tkStr,mTkStr,cmd4)
   endif
return tkId==mTkId .and. tkStr==mTkStr

//*******************************************************************
implement mleftXNToken(leftToken,cmd4)
/*
   Match left xtranslate normal token.
   Norml token (nem match s nem malterset) elemz.
   A this:item-ben lev tokent vizsglja, mg olvashat. 
   Ha az illeszts sikertelen, akkor a plusz beolvasott tokeneket
   visszateszi az inputra s a this:item-et visszalltja.
*/
local tkId, tkStr

   tkId:=TOKEN.(this:item):id
   tkStr:=TOKEN.(this:item):str
   
   if (isMatchNToken(tkId,tkStr,;
                     TOKEN.leftToken:id,TOKEN.leftToken:str,;
                     TOKEN.leftToken:eqType/*cmd4*/))
      return .t.
   endif
return .f.

//*******************************************************************
static function connectParamValues(paramValues,wParamValues)
local i

   if (paramValues[1]==PVT_IDX)
      if (len(paramValues[2])<len(wParamValues[2]))
         asize(paramValues[2],len(wParamValues[2]))
      endif
      for i:=1 to len(wParamValues[2])
         if (wParamValues[2][i]!=nil)
            if (paramValues[2][i]==nil)
               paramValues[2][i]:=wParamValues[2][i]
            else
               aappend(paramValues[2][i],wParamValues[2][i])
            endif
         endif
      end for
   else
      aappend(paramValues[2],wParamValues[2])
   endif
return nil

//*******************************************************************
implement mleftXMRToken(leftToken,cmd4,paramValues,nUres)
// MALTERSET
/*
   Az algoritmus:
   
      Megynk az alternatvkon, s megprbljuk illeszteni.
      Ha nem sikerlt, vissza az inputra a beolvasott tokeneket,
      s vesszk a kvetkezt.
      Ha sikerlt, akkor elrl kezdjk vgignzni az alternatvkat.
      Mj.: Ez vltozhat
      Ha az alternatvk egyike sem illeszkedett, akkor tovbbmegynk.
      Mj.: Az illeszts mindig sikeres, mert az res is benne van.
           a lehetsgek kztt, csak ilyenkor az olvasott
           tokent vissza kell tenni az inputra.
*/
local oldParserBuffer
local item,i,leftTokenList
local wParamValues
local gone,iGone

   gone:=.f.
   oldParserBuffer:=this:parserBuffer
   this:unrds()
   this:parserBuffer:=C.TBUFFER:onew()
   this:rds()
   item:=this:item
   leftTokenList:=MALTRSET.leftToken:alterset
   i:=1
   while(i<=len(leftTokenList))
      if (paramValues[1]==PVT_IDX)
         wParamValues:={paramValues[1],array(len(paramValues[2]))}
      else
         wParamValues:={paramValues[1],{}}
      endif
      if (2==(iGone:=this:parseTokenList(leftTokenList[i],cmd4,wParamValues)))
         // Sikerlt illeszteni.
         // A mostani parserBuffer-t hozz kell adni a rgihez.
         TBUFFER.oldParserBuffer:appendBuffer(this:parserBuffer)
         // A paramtereket hozz kell adni a rgihez.
         connectParamValues(paramValues,wParamValues)
         
         // jra vgignzzk a listt.
         this:parserBuffer:=C.TBUFFER:onew()
         this:rds()   
         item:=this:item
         i:=1
         nUres:=0
         gone:=.t.
      else
         // A mostani parserBuffert pedig el kell dobni (a tartalmt
         // visszatenni az inputra), a item-et pedig vissza kell 
         // lltani.
         this:unrds(TBUFFER.(this:parserBuffer):bItemNumber()-1)
         this:item:=item
         i++
      endif
   end while
   // Nem lehet tovbb menni, de az illeszts azrt sikeres!
   this:unrds()
   this:parserBuffer:=oldParserBuffer
   // A buffer vgn lev <space>-kat vissza kell rakni az
   // inputra.
   this:unrds(nUres)
return gone

//*******************************************************************
static function compareWNames(name,trName,cmd4)
// A name (ami az elemzend sorban van) illeszkedik-e a translate
// bal oldaln lev token-re.
// Sajnos nem ngy hosszan, hanem minimum 4 hosszan kell hasonltani,
// s nem mindegy, hogy mi illeszkedik mire.

   // Ez kell!!!
   if (len(name)>len(trName))
      return .f.
   endif
   
   if (empty(cmd4) .or. len(name)<4)
      return lower(name)==lower(trName)
   endif
   
//   Mj.: Ez lnyegben egy '=' (sszehasonlts), de az '=' 
//        obsoleted.
return (lower(name)==lower(left(trName,len(name))))

//*******************************************************************
static function matchLookForward(tkId,tkStr,forwTkId,forwTkStr,forwT,cmd4)

   if (forwTkId==TKID_RESTRICTED_MATCH_MARKER)
      // A spec nem nz elre ebben az esetben, ezrt ez nem kell.
      #ifdef OLD
      // Sajnos ez egyenlre nem j, mert a wordList-ben tokeneknek
      // kellene lennie, hogy a stringeket kln kezelhessk, 
      // ezenkvl az reseknl meg kellene llni, etc.
      // De ez egyenlre nincs kitesztelve.
      // Ezrt egyenlre a stringeket kihagyjuk.
      if (tkId==TKID_NEV .or.;
          tkId==TKID_SZAMTOMB .or.;
          ;//tkId==TKID_STRING .or.;
          tkId==TKID_CHAR)
         return 0!=ascan(RSMMARKR.forwT:wordList,;
                         {|x| compareWNames(tkStr,x,RSMMARKR.forwT:eqType/*cmd4*/)})
      endif
      #endif
      return .f.
   elseif (forwTkId==TKID_NEV .or. forwTkID==TKID_STRING)
      // A neveket s a stringeket 'case insensitive' mdon kell 
      // sszehasonltani.
      return tkId==forwTkId .and. compareWNames(tkStr,forwTkStr,RSMMARKR.forwT:eqType/*cmd4*/)
   endif

   // Itt mg lehetnek csavarsok pl. a szmokat rtkk szerint, 
   // vagy a stringeket gy, hogy nem szmt mivel hatroltk etc.
return tkId==forwTkId .and. tkStr==forwTkStr
   
//*******************************************************************
implement mleftXRMMToken(leftToken,cmd4)
/*
   Regular Match marker.
   Addig megy, amg egy kifejezs tart, vagy el nem ri a 
   leftToken:nextToken-t.
   Sajnos a specifikci nem kvetkezetes: 
   Pl: Ez nem egy kifejezs: 'a*+b', ez viszont igen: 'a*(+b)'

   A cmd4 az elrenzshez kell.    
*/
local state

#define STXRMM_START       "start"
#define STXRMM_PARENT      "parent"

local tkId,tkStr,ujsor
local parentStack
// local iForwRead
local clfBuf,clfNumBuf,elvalaszt
local clf
local endToken,endTkId,endTkStr
               
   this:startMakrobuf(this:item)
   clfBuf:={}
   clfNumBuf:={}
        
   // iForwRead:=1
   
   // Itt ki kell szrni az '='-t, mert azzal kifejezs nem kezddhet.
   // Kihasznljuk, hogy this:item jsor s res nem lehet.
   if (TOKEN.(this:item):id==TKID_CHAR .and.;
       TOKEN.(this:item):classify=='=')
      // Vajon itt kell unrds()?
      this:unrdsMakroBuf()
      return .f.
   endif

   endToken:=MMARKER.leftToken:nextToken
   if (MMARKER.leftToken:nextToken!=nil)
      endTkId:=TOKEN.(MMARKER.leftToken:nextToken):id
      endTkStr:=TOKEN.(MMARKER.leftToken:nextToken):str
   else
      endTkId:=nil
      endTkStr:=nil
   endif
   
   elvalaszt:=nil   
   state:=STXRMM_START
   while(this:item!=nil)
      tkId:=TOKEN.(this:item):id
      tkStr:=TOKEN.(this:item):str
      ujsor:=tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS .or.;
             (tkId==TKID_CHAR .and. tkStr==";")

      PDEBUG(outerr("mleftXRMMToken: ","state: ",state, "tkId: ",tkId, "tkStr: ", tkStr,crlf()))
      if (state==STXRMM_START)
         if (ujsor)
            // Vge!
            exit
         elseif (matchLookForward(tkId,tkStr,endTkId,endTkStr,endToken,cmd4))
         // elseif (tkId==endTkId .and. tkStr==endTkStr)
            // Ez itt problms, mert neveknl, vagy stringeknl nem 
            // tudjuk, hogyan kell az sszehasonltst csinlni.
            // (case sensitive, neveknl ngy karakter hosszan is
            // lehet (translate,command)
            // Vge!
            // Mj.: Nem biztos, hogy j a clBuf-beli visszalpseket 
            // kezelni kellene
            exit
         elseif (eqTkInCharList(tkId,tkStr,','))
            // Vge!
            exit
         elseif (eqTkInCharList(tkId,tkStr,')}]'))
            // Vge!
            exit
         elseif (tkId==TKID_URES)
            // Maradunk.
         elseif (eqTkInCharList(tkId,tkStr,'({['))
            // Elszr megnzzk, hogy jhet-e itt zrjel.
            aadd(clfBuf,TKCL_PARENT)
            // Amikor kijn a zrjelbl, ide be fogja rni a helyes
            // szmot.            
            aadd(clfNumBuf,len(this:makroBuf))
            if (nil!=(elvalaszt:=exprChk(clfBuf)))
               // Nem jhet.
               exit
            endif
            state:=STXRMM_PARENT
            parentStack:={thisclass:getCloseParent(tkStr)}
         elseif (nil!=(clf:=TOKEN.(this:item):classify))
            // Hozzvesszk a clfBuf-hoz, s megnzzk, hogy
            // jhet-e.
            if (clf=='++' .and. len(clfBuf)>0 .and. atail(clfBuf)=='++')
               clfNumBuf[len(clfNumBuf)]:=len(this:makroBuf)
            else
               aadd(clfBuf,clf)
               aadd(clfNumBuf,len(this:makroBuf))
               if (nil!=(elvalaszt:=exprChk(clfBuf)))
                  // Nem jhet. 
                  // Az elvalaszt-nl van a kifejezshatr.
                  exit
               endif
            endif
         else
            // Ide nem jhetnk, egyenlre elengedjk, brmi is van 
            // itt.
         endif
      elseif (state==STXRMM_PARENT)
         // Mj.: A clfNumBuf vgn a makrbuf hosszt azrt kell
         //      vezetni, hogy az res helyeket a vgn le tudjuk 
         //      vgni.
         if (ujsor)
            // Vge! 
            exit
         elseif (tkId==TKID_URES)
            // Maradunk.
         elseif (eqTkInCharList(tkId,tkStr,'({['))
            aadd(parentStack,thisclass:getCloseParent(tkStr))
            clfNumBuf[len(clfNumBuf)]:=len(this:makroBuf)
         elseif (eqTkInCharList(tkId,tkStr,')}]'))
            // Ha nem illeszkedik a stack-re, akkor nem vesszk
            // figyelembe, ha illeszkedik, akkor a stack-rl 
            // levesszk a legfels elemet.
            clfNumBuf[len(clfNumBuf)]:=len(this:makroBuf)
            if (atail(parentStack)==tkStr)
               adrop(parentStack)
               if (empty(parentStack))
                  state:=STXRMM_START
               endif
            endif
         else
            // Brmi ms, folytatdik az elemzs.
            clfNumBuf[len(clfNumBuf)]:=len(this:makroBuf)
         endif
      else
         ? "MPARSER:mleftXRMMToken(): Ismeretlen llapot: ",state
         errorlevel(1)
         quit
      endif
      this:rdsMakroBuf()
      // iForwRead++
   end while
        
   if (elvalaszt==nil)
      // Sor vge, vessz, etc.
      // Ha a clfBuf nem res, akkor az utolsra lpnk vissza, ha 
      // res, nem illeszkedett!
      if (len(clfBuf)==0)
         this:unrdsMakroBuf(len(this:makroBuf))
         return .f.
      endif
      // Mg meg kell nzni, hogy van-e kifejezshatr, gy, hogy
      // nem lehet folytatni.
      aadd(clfBuf,"newline")
      aadd(clfNumBuf,len(this:makroBuf))
      if (nil==(elvalaszt:=exprChk(clfBuf)))
         elvalaszt:=len(clfBuf)-1
      endif
   endif   
   // Ilyenkor az clfNumBuf[elvlaszt] azt mondja meg, hogy hova
   // kell visszalpnnk. Ennyi tokennek kell maradnia a 
   // makroBuf-ban.
   this:unrdsMakroBuf(len(this:makroBuf)-clfnumBuf[elvalaszt])
   // aappend(tokenList,this:makroBuf)
   
return !empty(this:makroBuf)

//*******************************************************************
#ifdef OLD
// Ez egsz jl mkdik, de sokat elront.
// implement mleftXRMMToken(leftToken,tokenList)
// /*
//    Regular Match marker.
//    Addig megy, amg egy kifejezs tart, vagy el nem ri a 
//    leftToken-ben megadott lezr tokent.
//    Sajnos a specifikci nem kvetkezetes: 
//    Pl: Ez nem egy kifejezs: 'a*+b', ez viszont igen: 'a*(+b)'
//     
// */
// 
// /*
//    A kifejezs elemzs a kvetkezkppen megy:
//    
//    Az elemek:
//       <Kifejezs token>: olyan token, ami megllja a helyt nll
//                          kifejezsknt.
//       <Elrevetett unris opertor>:
//                        '&','++','--','+','-','@','.not.','!'
//       <Htravetett unris opertor>:
//                        '--','++'
//       <binris opertor>:
//                       '$','%','*','**','^','+','-','->','.and.','.or.',
//                       '/',':',':=',
//                       '<','<=','<>','!=','#','=','==','>','>='
//                       
//       Specilis dolgok:
//         <szm>['.'[<szm>]]
//         
// 
//       Helyettestsek: 
//          '.not.' -> '!'
//          '**'    -> '^'
//          
//       Megjegyzsek: 
//            
//       - A <szm>.and. kifejezsben az els '.' a .and.-hoz 
//         tartozik, mert a .and. foglalt nv. Ugyanez vonatkozik 
//         a '.or.','.not.','.t.','.f.'-re. A kis s a nagybetket
//         nem klnbzteti meg.
//            
//       - A kt '&' jel ugyangy megjegyzs, mint a '//'
//       
//       - Egy opertornak tekinti a kvetkez tokenek tetsz. 
//         kombincijt: 
// 
//         '&','++','--','@','$','->','.and.','.or.','.not.','!',':=',
//         '<','<=','<>','!=','#','=','==','>','>=','.'
//          
//         Mj.: A fenti opertorokat unris opertornak tekinti.
//             
// 
//         Mj2.: A fentiek kzl a kvetkezk maradtak ki:
//               '+','-','*','**','^','/','%'
//         
//       - Specilisan kezelt tokenek:
//         '+': Csak binris lehet, eljel nem lehet.
//         '-': Binris s eljel lehet.
//         '*','**', '^', '/','%': csak binris opertorok lehetnek.
//            Mj.: A '*','/'-nek van egy specilis esete lsd 'Specilis
//                 esetek'.
//            
//       - Specilis esetek:
//         <brmi> '*' '/' <nv> : Ezt elfogadja egy kifejezsnek, de
//         pl.; a '*' '/' '*' '/'-t mr nem. 
//         Mj.: A <nv> helyn nem llhat semmit ms, mg j sor sem!
//         
//       - Az illesztst s az xtranslate elemzst is tokenesen 
//         csinlja (argh...) Pl.: ez a kt xtranslate parancs klnbzik
//         egymstl:
//         
//         #xtranslate HUHU <a> :=  <b> => let(@<a>,<b>)
//         #xtranslate HUHU <a> : = <b> => let(@<a>,<b>)
// 
//         Mj.: A msodikat el sem fogadja 'hinyz =>' hibajelzssel.
// 
//  
//         
//    Lehetsges, hogy a kifejezshatrok oldalrl jobban meg lehet fogni
//    a dolgot:
//    
//    <binris opertor>:='*'|'**'|'^'|'/'|'%'
//    
//    <Zrjelezett kifejezs>: '()', '{}','[]' kztt lev tetsz karakter
//                            sorozat. Az zrjeleken bell soha nincs 
//                            kifejezshatr.
// 
//    <pr nlkli csuk zrjel>: ')', '}',']' karater, amihez nincs 
//                                 megfelel nyit zrjel.
//    
//    Ekkor a kifejezs hatrok:
//    
//    <szm vagy nv> <kifejezshatr> <szm vagy nv>
//    '+' <kifejezshatr> <res> '+'
//    '+' <kifejezshatr> <binris opertor>
//    '-' <kifejezshatr> <res> '+'
//    '-' <kifejezshatr> <binris opertor>
//    '-' <kifejezshatr> <res> '-' <res> '-'
//    <Zrjelezett kifejezs> <kifejezshatr> <nv vagy szm>
//    <kifejezshatr> <pr nlkli zrjel>
//    <binris opertor> <kifejezshatr> <binris opertor>
//       Kivtel: '*' '/' <nv> // Itt nincs kifejezs hatr.
//    <binris opertor> <kifejezshatr> '+'
//    <binris opertor> <kifejezshatr> <nem '-',<szm>,<nv>,<nyit zrjel>.>
//    <kifejezshatr> ','
//    
//    Specilis esetek: 
//    
//    
//    '~': Ezt trli (?)
//    '`': Ezt string hatrolnak (") tekinti.
//    '.','|': Ezeket nem tekinti hatrolnak.
//    '&&': Ez egysoros megjegyzs, olyan, mint a '//'
//          
//    Brmilyen egyb esetben nincs kifejezs hatr.
// 
// */
// 
// local state
// 
// #define isTkIdNevSzam(tkId)  ((tkId)==TKID_NEV .or.;
//                               (tkid)==TKID_SZAMTOMB)
//                             
// #define isTkIdLiteral(tkId)  (isTkIdNevSzam(tkId) .or.;
//                              (tkid)==TKID_STRING)
//                             
// #define isTkClassify(tkId,token,clsfy)  ((tkId)==TKID_CHAR .and.;
//                                          TOKEN.(token):classify==(clsfy))
//                             
// #define STXRMM_XSTART      "xstart"
// #define STXRMM_START       "start"
// #define STXRMM_LITERAL     "literal"
// #define STXRMM_PLUS        "plus"
// #define STXRMM_MINUS       "minus"
// #define STXRMM_MINUS2      "minus2"
// #define STXRMM_PARENT      "parent"
// #define STXRMM_CSILLAG     "csillag"
// #define STXRMM_CSILLAGPER  "csillagper"
// #define STXRMM_BINARY      "binary"
//            
// local tkId,tkStr,ujsor
// local parentStack
// local iForwRead
// local clfBuf
//                
//    iForwRead:=1
//    
//    this:startMakrobuf(this:item)
//    state:=STXRMM_XSTART
//    clfBuf:={}
//    
//    while(this:item!=nil)
//       tkId:=TOKEN.(this:item):id
//       tkStr:=TOKEN.(this:item):str
//       ujsor:=tkId==TKID_UJSOR .or.;
//              tkId==TKID_BOS .or. tkId==TKID_EOS .or.;
//              (tkId==TKID_CHAR .and. tkStr==";")
// 
//       PDEBUG(outerr("state: ",state, "tkId: ",tkId, "tkStr: ", tkStr,crlf()))
//       if (state==STXRMM_XSTART)
//          if (ujsor)
//             // Vge!
//             exit
//          elseif (tkId==TKID_URES)
//             // Maradunk.
//          elseif (isTkClassify(tkId,this:item,'='))
//             // Vge!
//             exit
//          else
//             iForwRead:=0
//             this:unrdsMakroBuf()
//             state:=STXRMM_START
//          endif
//       elseif (state==STXRMM_START)
//          if (ujsor)
//             // Vge!
//             exit
//          elseif (tkId==TKID_URES)
//             // Maradunk.
//          elseif (isTkIdLiteral(tkId))
//             iForwRead:=0
//             state:=STXRMM_LITERAL
//          elseif (eqTkInCharList(tkId,tkStr,'({['))
//             iForwRead:=0
//             state:=STXRMM_PARENT
//             parentStack:={thisclass:getCloseParent(tkStr)}
//          elseif (eqTkInCharList(tkId,tkStr,')}]'))
//             // Vge (!)
//             exit
//          elseif (eqTkChar(tkId,tkStr,','))
//             // Vge (!)
//             exit
//          elseif (isTkClassify(tkId,this:item,'!'))
//             // Ezutn soha nincs kifejezs hatr.
//             iForwRead:=0
//             // Maradunk.
//          elseif (isTkClassify(tkId,this:item,'@'))
//             // Ezutn soha nincs kifejezs hatr.
//             iForwRead:=0
//             // Maradunk.
//          elseif (isTkClassify(tkId,this:item,'%'))
//             // Hasonl a '/'-hez s a '*'-hoz, de nincs kivtel.
//             // Utna jhet: '&', '- nev', '- szm', 'nev','szam',
//             //              'zrjel', '.t.'
//             iForwRead:=0
//             // state:=STXRMM_PERCENT
//             state:=STXRMM_BINARY
//          elseif (isTkClassify(tkId,this:item,'^'))
//             // Hasonl a '/'-hez s a '*'-hoz, de nincs kivtel.
//             // Utna jhet: '&', '- nev', '- szm', 'nev','szam',
//             //              'zrjel', '.t.'
//             iForwRead:=0
//             // state:=STXRMM_POW
//             state:=STXRMM_BINARY
//          elseif (isTkClassify(tkId,this:item,'&'))
//             // Mindent elfogad.
//             iForwRead:=0
//          elseif (eqTkChar(tkId,tkStr,'*'))
//             // A '*' '/' <name> specilis eset kezelse.
//             iForwRead:=0
//             state:=STXRMM_CSILLAG
//             PDEBUG(outerr("start->csillag"+crlf()))
//          elseif (eqTkChar(tkId,tkStr,'-'))
//             iForwRead:=0
//             state:=STXRMM_MINUS
//          elseif (eqTkChar(tkId,tkStr,'+'))
//             iForwRead:=0
//             state:=STXRMM_PLUS
//          elseif (isTkClassify(tkId,this:item,'='))
//             // Mivel nem ez az els karakter, brmit el lehet 
//             // fogadni.
//             iForwRead:=0
//             // Maradunk.
//          /*
//          elseif (isTkClassify(tkId,this:item,'/'))
//          elseif (isTkClassify(tkId,this:item,'++'))
//          elseif (tkId==TKID_NEV)
//          elseif (tkId==TKID_SZAMTOMB)
//          elseif (tkId==TKID_STRING)
//          */
//          else
//             // Brmi ms, maradunk.
//             iForwRead:=0
//          endif
//       elseif (state==STXRMM_LITERAL)
//          if (ujsor)
//             // Vge!
//             exit
//          elseif (tkId==TKID_URES)
//             // Maradunk.
//          elseif (isTkIdLiteral(tkId))
//             // Vge
//             exit
//          else
//             // Brmi ms: jra fel kell dolgozni.
//             iForwRead--
//             this:unrdsMakroBuf()
//             state:=STXRMM_START
//          endif
//       elseif (state==STXRMM_PLUS)
//          if (ujsor)
//             // Vge!
//             exit
//          elseif (tkId==TKID_URES)
//             // Maradunk.
//          elseif (eqTkChar(tkId,tkStr,'+'))
//             // Vge.
//             exit
//          elseif (thisclass:isTkBinaryOp(tkId,tkStr))
//             // *, **, ^,/,%
//             // Vge.
//             exit
//          else
//             // Brmi ms: jra fel kell
//             // dolgozni.
//             iForwRead--
//             this:unrdsMakroBuf()
//             state:=STXRMM_START
//          endif
//       elseif (state==STXRMM_MINUS)
//          if (ujsor)
//             // Vge!
//             exit
//          elseif (tkId==TKID_URES)
//             // Maradunk.
//          elseif (eqTkChar(tkId,tkStr,'+'))
//             // Vge.
//             exit
//          elseif (thisclass:isTkBinaryOp(tkId,tkStr))
//             // *, **, ^,/,%
//             // Vge.
//             exit
//          elseif (eqTkChar(tkId,tkStr,'-'))
//             state:=STXRMM_MINUS2
//          else
//             // Brmi ms: jra fel kell dolgozni.
//             iForwRead--
//             this:unrdsMakroBuf()
//             state:=STXRMM_START
//          endif
//       elseif (state==STXRMM_MINUS2)
//          if (ujsor)
//             // Vge! 
//             exit
//          elseif (tkId==TKID_URES)
//             // Maradunk.
//          elseif (isTkIdNevSzam(tkId)) // A string itt nem j!
//             // Elmegy.
//             iForwRead:=0
//             state:=STXRMM_LITERAL
//          else
//             // Brmi ms: kifejezshatr az els minusz utn!
//             exit
//          endif
//       elseif (state==STXRMM_PARENT)
//          if (ujsor)
//             // Vge! 
//             exit
//          elseif (tkId==TKID_URES)
//             // Maradunk.
//          elseif (eqTkInCharList(tkId,tkStr,'({['))
//             iForwRead:=0
//             aadd(parentStack,thisclass:getCloseParent(tkStr))
//          elseif (eqTkInCharList(tkId,tkStr,')}]'))
//             // Ha nem illeszkedik a stack-re, akkor nem vesszk
//             // figyelembe, ha illeszkedik, akkor a stack-rl 
//             // levesszk a legfels elemet.
//             iForwRead:=0
//             if (atail(parentStack)==tkStr)
//                adrop(parentStack)
//                if (empty(parentStack))
//                   state:=STXRMM_START
//                endif
//             endif
//          else
//             // Brmi ms, folytatdik az elemzs.
//             iForwRead:=0
//          endif
//       elseif (state==STXRMM_CSILLAG)
//          if (ujsor)
//             // Vge! 
//             exit
//          elseif (tkId==TKID_URES)
//             // Maradunk.
//          elseif (eqTkChar(tkId,tkStr,'/'))
//             state:=STXRMM_CSILLAGPER
//             PDEBUG(outerr("csillag->csillagper"+crlf()))
//          else
//             // Az aktulis item-et a binaris opertorok elemzjvel 
//             // kell elemeztetni.
//             iForwRead--
//             this:unrdsMakroBuf()
//             state:=STXRMM_BINARY
//          endif
//       elseif (state==STXRMM_CSILLAGPER)
//          if (ujsor)
//             // Vge! 
//             exit
//          elseif (tkId==TKID_URES)
//             // Maradunk.
//          elseif (tkId==TKID_NEV)
//             // Ok. Elkerltk a kifejezshatrt.
//             // Gyorstunk, egybl a literlhoz megynk.
//             iForwRead:=0
//             state:=STXRMM_LITERAL
//             PDEBUG(outerr("csillagper->literal"+crlf()))
//          else
//             // A '*' s a '/' kztt van a kifejezshatr.
//             exit
//          endif
//       elseif (state==STXRMM_BINARY)
//          if (ujsor)
//             // Vge! 
//             exit
//          elseif (tkId==TKID_URES)
//             // Maradunk.
//          elseif (tkId==TKID_NEV)
//             // Ok. Elkerltk a kifejezshatrt.
//             iForwRead:=0
//             state:=STXRMM_LITERAL
//          else
//             // A '*' s a '/' kztt van a kifejezshatr.
//             exit
//          endif
//       else
//          ? "MPARSER:mleftXRMMToken(): Ismeretlen llapot: ",state
//          errorlevel(1)
//          quit
//       endif
//       this:rdsMakroBuf()
//       iForwRead++
//    end while
//         
//    this:unrdsMakroBuf(iForwRead)
//    aappend(tokenList,this:makroBuf)
//    
// return !empty(this:makroBuf)
#endif

//*******************************************************************
implement mleftXWMToken(leftToken)
/*
   Wild matchmarker.
   
   Egy '()' kz zrt sorozat, vagy a leghosszabb space mentes
   sorozat.
   Mj.: Ha '('-al kezddik, s nincs lezrva, akkor is '()'-nek veszi.
   Mj2.: A tbbi zrjelet nem veszi figyelembe.
   Mj3.: Nem nz elre.
    
*/
local tkId,tkStr,ujsor
               
   this:startMakrobuf(this:item)
   
   while(this:item!=nil)
      tkId:=TOKEN.(this:item):id
      tkStr:=TOKEN.(this:item):str
      ujsor:=tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS .or.;
             (tkId==TKID_CHAR .and. tkStr==";")

      PDEBUG(outerr("mleftXWMToken: "+"tkId: ",tkId, "tkStr: ", tkStr,crlf()))
      if (ujsor)
         // Vge!
         this:unrdsMakroBuf()
         exit
      endif
      this:rdsMakroBuf()
   end while
        
return !empty(this:makroBuf)


//*******************************************************************
implement mleftXEEMToken(leftToken)
/*
   Extended Expression match marker.
   
   Egy '()' kz zrt sorozat, vagy a leghosszabb space mentes
   sorozat.
   Mj.: Ha '('-al kezddik, s nincs lezrva, akkor is '()'-nek veszi.
   Mj2.: A tbbi zrjelet nem veszi figyelembe.
   Mj3.: Nem nz elre.
    
*/
local state

#define STXEEM_START       "start"
#define STXEEM_PARENT      "parent"
#define STXEEM_SOROZAT     "sorozat"

local tkId,tkStr,ujsor
local numParent
               
   this:startMakrobuf(this:item)
   
   state:=STXEEM_START
   while(this:item!=nil)
      tkId:=TOKEN.(this:item):id
      tkStr:=TOKEN.(this:item):str
      ujsor:=tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS .or.;
             (tkId==TKID_CHAR .and. tkStr==";")

      PDEBUG(outerr("mleftXEEMToken: ","state: ",state, "tkId: ",tkId, "tkStr: ", tkStr,crlf()))
      if (state==STXEEM_START)
         if (ujsor)
            // Vge!
            this:unrdsMakroBuf()
            exit
         elseif (tkId==TKID_URES)
           // Lenyeli
         elseif (eqTkInCharList(tkId,tkStr,'('))
            // Zrjelezett md.
            numParent:=1
            state:=STXEEM_PARENT
         else
            // Space nlkli sorozat md
            state:=STXEEM_SOROZAT
         endif
      elseif (state==STXEEM_PARENT)
         if (ujsor)
            // Vge! 
            this:unrdsMakroBuf()
            exit
         elseif (eqTkInCharList(tkId,tkStr,'('))
            numParent++
         elseif (eqTkInCharList(tkId,tkStr,')'))
            numParent--
            if (numParent<=0)
               exit
            endif
         else
            // Brmi ms, folytatdik az elemzs.
            // Ebben benne van az res is.
         endif
      elseif (state==STXEEM_SOROZAT)
         if (ujsor)
            // Vge! 
            this:unrdsMakroBuf()
            exit
         elseif (tkId==TKID_URES)
            // Vge! 
            this:unrdsMakroBuf()
            exit
         else
            // Brmi ms, folytatdik az elemzs.
         endif
      else
         ? "MPARSER:mleftXEEMToken(): Ismeretlen llapot: ",state
         errorlevel(1)
         quit
      endif
      this:rdsMakroBuf()
   end while
        
return !empty(this:makroBuf)

//*******************************************************************
implement mleftXLMToken(leftToken,cmd4)
// List match marker
// Az res paramtert (,,) megengedi.
local params:={}
local iForwRead
local tkId,tkStr,ujsor


   this:mleftXRMMToken(leftToken,cmd4)
   this:rds()
   aadd(params,this:makroBuf)
             
   iForwRead:=1
   
   while(this:item!=nil)
      tkId:=TOKEN.(this:item):id
      tkStr:=TOKEN.(this:item):str
      ujsor:=tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS .or.;
             (tkId==TKID_CHAR .and. tkStr==";")
   
      if (ujsor)
         // Vge!
         exit
      elseif (tkId==TKID_URES)
         // Maradunk.
      elseif (eqTkChar(tkId,tkStr,','))
         this:rds()
         if (this:mleftXRMMToken(leftToken,cmd4))
            aadd(params,this:makroBuf)
         else
            aadd(params,{})
         endif
         iForwRead:=0
      else
         // Brmi ms, vge.
         exit
      endif
      iForwRead++
      this:rds()
   end while
   
   this:unrds(iForwRead)
   if (len(params)==1 .and. len(params[1])==0)
      return .f.
   endif
   this:makroBuf:=params
return .t.

//*******************************************************************
implement mleftXRSMMToken(leftToken,cmd4)
/*
   Restricted match marker.
   
   Csan nevekre, szmokra s karakterekre illesztnk.
*/
local tkId, tkStr,wl,i

   this:startMakrobuf(this:item)
   
   tkId:=TOKEN.(this:item):id
   tkStr:=TOKEN.(this:item):str
   
   if !(tkId==TKID_NEV .or.;
       tkId==TKID_SZAMTOMB .or.;
       ;//tkId==TKID_STRING .or.;
       tkId==TKID_CHAR)
      return .f.
   endif
   
   wl:=RSMMARKR.leftToken:wordList
   if (empty(wl))
      return .f.
   endif
   
   for i:=1 to len(wl)
      if (empty(wl[i]))
         this:unrdsMakrobuf()
         return .t.
      endif
      if (compareWNames(tkStr,wl[i],TOKEN.leftToken:eqType/*cmd4*/))
         return .t.
      endif
   end for
return .f.

//*******************************************************************
/*
cimplement isTkBinaryOp(tkId,tkStr)
// Ez a nem tokenizlt vltozat.

   if (!tkId==TKID_CHAR)
      return .f.
   endif
   
return tkStr$"*^/%"
*/   
//*******************************************************************


